Pie 【hdu-1969】【二分】

Pie

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 14949    Accepted Submission(s): 5290


Problem Description
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size. 

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
 

Input
One line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.
 

Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
 

Sample Input
 
  
3 3 3 4 3 3 1 24 5 10 5 1 4 2 3 4 5 6 5 4 2
 

Sample Output
 
  
25.1327 3.1416 50.2655

题意:有n块馅饼,给出n块馅饼的半径,分给f+1个人(包括自己);问每个人分得的大小(每个人只能得到一整块,可以是从一块馅饼上切下来的,但不能是多个馅饼拼凑的)

题解:通过二分搜索不断缩小最优解的范围,在选取范围时,通过判定是否符合条件来取舍。其中要注意精度的控制。


#include<cstdio>
#include<cstring>
#include<cmath>
#include<iostream>
#include<algorithm>
using namespace std;
double a[10005];
int n,f;

bool C(double x){
	int num=0;
	for(int i=0;i<n;i++){
		num+=(int) (a[i]/x);
	}
	return num>=f;
}

int main()
{
	int T;
	double pi=acos(-1.0);
	scanf("%d",&T);
	while(T--){
		
		scanf("%d%d",&n,&f);
		f++;
		for(int i=0;i<n;i++){
			scanf("%lf",&a[i]);
			a[i]=a[i]*a[i]*pi;
		}
		
		sort(a,a+n);
	
		double lb=0,ub=a[n-1];
		
		for(int i=0;i<100;i++){
			double mid=(lb+ub)/2;
			if(C(mid)) lb=mid;
			else ub=mid;
		}
		printf("%.4f\n",ub);
	}
	
	return 0;
 } 


发布了79 篇原创文章 · 获赞 5 · 访问量 1万+

猜你喜欢

转载自blog.csdn.net/DNMTOOBA/article/details/79572022